/*
 * menu.h
 *
 *  Created on: Nov 12, 2010
 *      Author: Automatyk
 */

#ifndef MENU_H_
#define MENU_H_


#include <stddef.h>
#include "stm32f10x.h"
#include "nokia_lcd.h"
#include <string.h>

#define NO_KEY		0
#define KEY_DN		1
#define KEY_UP		2
#define KEY_L		3
#define KEY_R		4
#define KEY_OK		5

extern void delay_ms(uint32_t time);

void menu();
void show_menu(uint8_t menu_no, uint8_t submenu_no);
void enter_menu(uint8_t menu_no, uint8_t submenu_no);
void exit_from_menu();

void graphic_menu();
void show_graphic_menu(uint8_t menu_no, uint8_t submenu_no);
void enter_graphic_menu(uint8_t menu_no, uint8_t submenu_no);
void exit_from_graphic_menu();

void slide_down();
void slide_up();

int16_t enter_integer(int16_t val, int16_t min, int16_t max, uint8_t x, uint8_t y, char *var_name, char *var_unit);

extern int getkey(void);

//////////////////////////////////////////////////////////////////////
// WAZNE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  //
// adresowanie tablicy menu_strings w postaci [submenu][menu]       //
// czyli troche na odwrot                                           //
//////////////////////////////////////////////////////////////////////

static const char *menu_strings[9][8]={				// menu_strings[submenu, menu]
		{"MENU1", "MENU2", "MENU3","MENU4","MENU5","MENU6","MENU7","MENU8"},
		{"MENU1.1", "MENU2.1", "MENU3.1","","","MENU6.1","",""},
		{"MENU1.2","MENU2.2", "MENU3.2","","","","",""},
		{"MENU1.3","","","","","","",""},
		{"MENU1.4","","","","","","",""},
		{"MENU1.5","","","","","","",""},
		{"MENU1.6","","","","","","",""},
		{"MENU1.7","","","","","","",""},
		{"MENU1.8","","","","","","",""}
};


#endif /* MENU_H_ */
